#!/usr/bin/env python3.8
"""Phantom API Client: Models.Note
Copyright © 2019 Jerod Gawne <https://github.com/jerodg/>

This program is free software: you can redistribute it and/or modify
it under the terms of the Server Side Public License (SSPL) as
published by MongoDB, Inc., either version 1 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
SSPL for more details.

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

You should have received a copy of the SSPL along with this program.
If not, see <https://www.mongodb.com/licensing/server-side-public-license>."""

from dataclasses import dataclass
from typing import Union


@dataclass
class Note:
    title: str
    content: str
    container_id: Union[int, None] = None
    phase_id: Union[int, None] = None

    @property
    def dict(self):
        return dict(sorted({k: v for k, v in self.__dict__.items() if v is not None}.items()))
